module Ubc.Parse.Scope.StructScope
( StructScope(..)
, modifyVariables
)
where

import Data.Map (Map)

import Ubc.Parse.VariableType (VariableType)

data StructScope = StructScope
        { structName :: String
        , variables :: Map String VariableType
        }

modifyVariables :: (Map String VariableType -> Map String VariableType) -> StructScope -> StructScope
modifyVariables f scope@StructScope{variables = oldVariables} = scope{variables = newVariables}
        where
                newVariables = f oldVariables
